#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>

using namespace std;



int Sum(const vector<int> & sumTable, int pivot, int length)
{
  //cerr << "sum "  << length << " at " << pivot << endl;
  return sumTable[pivot+length-1] - ((pivot < 1) ? 0 : sumTable[pivot-1]);
}



int minAlign(int pivot, int length, const vector<int> & sumTable)
{
  //cerr << "align" << endl;
  int minCost = INT_MAX;
  for(int i = length; i--; )
    minCost = min(minCost, Sum(sumTable, pivot - i, length));
  return minCost;
}


/*
int findPivot(const vector<int> & costs, const vector<int> & sumTable)
{
  //cerr << "pivot" << endl;
  int numPockets = costs.size()/3;
  vector<int> maxs(1,0);
  for(int i = numPockets; i--; )
  {
    const int index = i + numPockets;
    if(costs[index] == costs[maxs[0]])
      maxs.push_back(index);
    else if(costs[index] > costs[maxs[0]])
      maxs = vector<int>(1, costs[index]);
  }
  //cerr << "pivot2" << endl;
  if(maxs.size() == 1)
    return maxs[0];
  else
  {
    int bestMax = maxs[0];
    int bestCost = INT_MAX;
    for(int i = maxs.size(); i--; )
    {
      int cost = minAlign(maxs[i], numPockets/2, sumTable);
      if(cost < bestCost)
      {
        bestMax = maxs[i];
        bestCost = cost;
      }
    }
    return bestMax;
  }
}
*/


int findPivot(const vector<int> & costs, const vector<int> & sumTable)
{
  int numPockets = costs.size()/3;
  int bestIndex = numPockets;
  int bestCost = 0;
  int bestCost2 = INT_MAX;
  const int betSize = numPockets/2;
  for(int i = numPockets; i--; )
  {
    const int index = numPockets + i;
    if(costs[index] > bestCost)
    {
      bestCost2 = INT_MAX;
      bestCost = costs[index];
      bestIndex = index;
    }
    else if(costs[index] == bestCost)
    {
      if(bestCost2 == INT_MAX)
        bestCost2 = minAlign(bestIndex, betSize, sumTable);
      const int cost2 = minAlign(index, betSize, sumTable);
      if(cost2 < bestCost2)
      {
	bestCost2 = cost2;
	bestCost = costs[index];
	bestIndex = index;
      }
    }
  }
  return bestIndex;
}



int main(int, char**)
{
  int numPockets;

  while(cin >> numPockets)
  {
    if(numPockets == 0)
      break;
    vector<int> costs(numPockets * 3);
    vector<int> sumTable(numPockets * 3, 0);
    for(int i = 0; i < numPockets; i++)
    {
      int cost;
      cin >> cost;
      costs[i] = costs[i+numPockets] = /*costs[i+numPockets*2] = */cost;
    }
    sumTable[0] = costs[0];
    for(int i = 1; i < sumTable.size()/3*2; i++)
      sumTable[i] = costs[i] + sumTable[i-1];
    int pivot = findPivot(costs, sumTable);
    int betLength = numPockets/2;
    int totalCost = minAlign(pivot, betLength, sumTable)
                  + Sum(sumTable, pivot + 1, betLength)
                  + Sum(sumTable, pivot - betLength, betLength);
    cout << totalCost << endl;
  }

  return 0;
}
