#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;


int FindBest(vector<int> & nums, const vector<bool> & valid, int limit)
{
  int index = 0;

  for(int i = nums.size(); i--; )
    if((nums[index] > nums[i]) && valid[i])
      index = i;

  for(int i = nums.size(); i--; )
    if((nums[i] <= limit) && (nums[i] > nums[index]) && valid[i])
      index = i;

  return index;
}




int Help(vector<int> nums)
{
  int A = 0, B = 0;
  int maxDiff = 0;
  vector<bool> valid (nums.size(), true);
  int remaining = nums.size();

  while(remaining--)
  {
    int diff = abs(A - B);

    maxDiff = max(diff, maxDiff);

    int index = FindBest(nums, valid, 2 * maxDiff);
    cout << nums[index] << '-' << ((A<B) ? 'A' : 'B') << ' ';
    ((A<B) ? A : B) += nums[index];
    valid[index] = false;
  }
  cout << endl;
  return maxDiff;
}



int main(int, char**)
{
  int numNums;
  while(cin >> numNums)
  {
    if(numNums == 0)
      break;
    vector<int> nums(numNums);
    for(int i = nums.size(); i--; )
    cin >> nums[i];
    //cerr << Help(nums) << endl;
    Help(nums);
  }
  
  return 0;
}
